﻿--[[
    Name:           Titan SimpleMp3
	Description:	Titan Panel interface for SimpleMp3.
	Author:         Suddendeath2000
       SimpleMP3 Player maintained by Paradox
	Version:        3.3.1
    --]]

TMP3ID = "SimpleMp3"
TMP3Version = "3.3.1"
TMP3C1 = "|cffffffff"
TMP3C2 = "|cffcc00ff"
TMP3C3 = "|cff00ff00"
TMP3C4 = "|cffffcc00"
TMP3Announce = "Announce Song"
TMP3ShowTimer = "Show Timer"
TMP3Time = "0:00"
TMP3Timer = "0:00"
_ ={}
TMP3englishFaction, _ = UnitFactionGroup("player")
 
function TitanPanelSimpleMp3Button_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage(TMP3C1.."Titan Panel "..TMP3C2.."["..TMP3ID.."] "..TMP3C1.."v"..TMP3C2..TMP3Version.." "..TMP3C1.."by |cff999999Suddendeath2000")
            
    this:RegisterEvent("PLAYER_LOGOUT")
    this:RegisterEvent("ADDON_LOADED")
    
    self.registry = {
		id = TMP3ID,
	    version = TMP3Version,
        menuText = TMP3ID,
        buttonTextFunction = "TitanPanelSimpleMp3Button_GetButtonText",	
        category = "Interface",
        tooltipTitle = TMP3C4..TMP3ID,
		tooltipTextFunction = "TitanPanelSimpleMp3Button_GetTooltipText",
        iconButtonWidth = 16,
        iconWidth = 16,        
        savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,  
            ShowTooltipText = 1,
            ShowMenuOptions = 1,
            ShowAdvancedMenus = 1,         
    }}
end

function TitanPanelSimpleMp3Button_GetButtonText()
    Button = TitanUtils_GetButton(TMP3ID, true)    
    TMP3SongInfo = PLInfo('song', Smp3_Save.Current).." by "..PLInfo('artist', Smp3_Save.Current)
    if Smp3_Save.ScrollText:match(SIMPLEMP3_DEFAULT_SCROLLTEXT) then return "SimpleMp3: "..GREEN_FONT_COLOR_CODE.."No Music in Playlist"
      else return TMP3C4.."SimpleMp3: "..TMP3C3..TMP3SongInfo.."  "..TMP3C1..TMP3Time
  end
    if TMP3englishFaction == "Alliance" then TMP3Language = "Common"
      elseif TMP3englishFaction == "Horde" then TMP3Language = "Orcish"     
  end
    
   
end

function TitanPanelSimpleMp3Button_GetTooltipText()
	return TMP3C3.."Right-Click to Open Menu\n"..TMP3C3.."Double Left-Click to Play/Stop\n"..TMP3C3.."Shift/Double Left-click for Next Song\n"..TMP3C3.."Control/Double Left-click for Previous Song\n"..TMP3C3.."Mousewheel Changes Volume"
end

function TitanPanelSimpleMp3Button_OnDoubleClick(self, button)
    if button == "LeftButton" then
      if IsShiftKeyDown() then SimpleMp3_PrevCLick()        
        elseif IsControlKeyDown() then SimpleMp3_NextClick()        
          else SimpleMp3_PlayStopClick()
    end
  end
end 

function TitanPanelRightClickMenu_PrepareSimpleMp3Menu()    
    local info = {}
    
    
    if  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TMP3Announce)then
      TitanPanelRightClickMenu_AddTitle(TMP3Announce, UIDROPDOWNMENU_MENU_LEVEL)
      
 
		info.text = "Say Channel"
        info.checked = TMP3SayChatAnnounce == true
		info.func = function ()  TitanPanelSimpleMp3Say()   end        
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)    
     
		info.text = "Guild Channel"
        info.checked = TMP3GuildChatAnnounce == true
		info.func = function ()  TitanPanelSimpleMp3Guild()  end        
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
   
		info.text = "Party Channel"
        info.checked = TMP3PartyChatAnnounce == true
		info.func = function ()  TitanPanelSimpleMp3Party()  end        
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
     
		info.text = "Raid Channel"
        info.checked = TMP3RaidChatAnnounce == true
		info.func = function ()  TitanPanelSimpleMp3Raid()   end        
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
       
		info.text = "Emote"
        info.checked = TMP3EmoteChatAnnounce == true
		info.func = function ()  TitanPanelSimpleMp3Emote()   end        
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    elseif ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TMP3ShowTimer)then
      TitanPanelRightClickMenu_AddTitle(TMP3ShowTimer, UIDROPDOWNMENU_MENU_LEVEL)
    
        info.text = "Show Elapsed Time"
        info.checked = Smp3_Save.Remaining == false
		info.func = function () Smp3_Save.Remaining = false
                                SimpleMp3FormMp3Time:Hide()
                                SimpleMp3FormMp3Time2:Show() end    
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
       
		info.text = "Show Remaining Time"
        info.checked = Smp3_Save.Remaining == true
		info.func = function () Smp3_Save.Remaining = true
                                SimpleMp3FormMp3Time2:Hide()
                                SimpleMp3FormMp3Time:Show() end        
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
    
    else
    
        TitanPanelRightClickMenu_AddTitle(TMP3ID)
        TitanPanelRightClickMenu_AddSpacer()
      
		info.text = "Open Player"
		info.func = function() SimpleMp3Form:Show() end
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
        
		info.text = "Open Playlist"
		info.func = function() SimpleMp3PlaylistForm:Show() end
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = "Open Library"
		info.func = function() SimpleMp3LibraryForm:Show() end
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)                            
     
		info.text = "Toggle Volume Slider"
		info.func = TitanPanelSimpleMp3Volume
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info = {}
		info.text = TMP3ShowTimer
        info.value = TMP3ShowTimer
        info.hasArrow = 1
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info = {}
		info.text = TMP3Announce
        info.value = TMP3Announce
        info.hasArrow = 1
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info = {}
		info.text = "Shuffle Music"
		info.func = function () SimpleMp3_ShuffleClick() end
        info.checked = Smp3_Save.isShuffled == true
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
       
        info.text = "Show Minimap Button"
		info.func = TitanPanelSimpleMp3Minimap
        info.checked = SimpleMp3MiniMapButton:IsVisible()
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddToggleIcon(TMP3ID)
  end 
end

function TitanPanelSimpleMp3Button_OnEvent(event, arg1)
    local SliderVar = getglobal("SimpleMp3VolumeForm" .. "Slider")
    if event == "PLAYER_LOGOUT" then TitanPanelSimpleMp3TimeOver = TitanPanelSimpleMp3Time
                                     TMP3MinimapButtonOver = TMP3MinimapButton                                     
                                     TMP3SayChatAnnounceOver = TMP3SayChatAnnounce
                                     TMP3GuildChatAnnounceOver = TMP3GuildChatAnnounce
                                     TMP3PartyChatAnnounceOver = TMP3PartyChatAnnounce
                                     TMP3RaidChatAnnounceOver = TMP3RaidChatAnnounce
                                     TMP3EmoteChatAnnounceOver = TMP3EmoteChatAnnounce
                                     TitanPanelSimpleMp3ChatOver = TitanPanelSimpleMp3Chat
                                     
                                     
  end
    if event == "ADDON_LOADED" and arg1 == "TitanSimpleMp3" then TMP3MinimapButton = TMP3MinimapButtonOver                                    
                                    TitanPanelSimpleMp3Time = TitanPanelSimpleMp3TimeOver
                                    TMP3SayChatAnnounce = TMP3SayChatAnnounceOver
                                    TMP3GuildChatAnnounce = TMP3GuildChatAnnounceOver
                                    TMP3PartyChatAnnounce = TMP3PartyChatAnnounceOver
                                    TMP3RaidChatAnnounce = TMP3RaidChatAnnounceOver
                                    TMP3EmoteChatAnnounce = TMP3EmoteChatAnnounceOver
                                    TitanPanelSimpleMp3Chat = TitanPanelSimpleMp3ChatOver
                                    TPSong2 = nil
                                    TMP3PartyNum = 0
                                    SliderVar:SetValue(0.5)
  end    
    if TMP3MinimapButton == false then TMP3MinimapButton = true
      elseif TMP3MinimapButton == true then TMP3MinimapButton = false
  end 
  TitanPanelSimpleMp3Minimap()  
end
      
function TitanPanelSimpleMp3Volume()
    if (SimpleMp3VolumeForm:IsVisible()) then SimpleMp3VolumeForm:Hide()
	  else SimpleMp3VolumeForm:Show()
  end
end

function TitanPanelSimpleMp3Timer()
    if TitanPanelSimpleMp3Time == true then TitanPanelSimpleMp3Time = false
      else TitanPanelSimpleMp3Time = true
  end
end

function TitanPanelSimpleMp3Minimap()
    if TMP3MinimapButton == true then TMP3MinimapButton = false
      else TMP3MinimapButton = true
  end
  TitanPanelSimpleMp3MinimapToggle()
end

function TitanPanelSimpleMp3MinimapToggle()    
    if TMP3MinimapButton == true then SimpleMp3MiniMapButton:Show()
      elseif TMP3MinimapButton == false then SimpleMp3MiniMapButton:Hide()
  end
end

function TitanPanelSimpleMp3ChatAnnounce()
    if TitanPanelSimpleMp3Chat == true then TitanPanelSimpleMp3Chat = false
      else TitanPanelSimpleMp3Chat = true
  end
    if TitanPanelSimpleMp3Chat == false then TMP3SayChatAnnounce = false
                                             TMP3GuildChatAnnounce = false
                                             TMP3PartyChatAnnounce = false
                                             TMP3RaidChatAnnounce = false
                                             TMP3EmoteChatAnnounce = false
  end                                           
end

function TitanPanelSimpleMp3Say()   
    if TMP3SayChatAnnounce == true then TMP3SayChatAnnounce = false
      else TMP3SayChatAnnounce = true
        end
    if isPlaying == true and TMP3SayChatAnnounce == true and TitanPanelSimpleMp3Chat == true then SendChatMessage("I'm listening to "..TMP3SongInfo, "SAY", TMP3Language, _)      
  end
end

function TitanPanelSimpleMp3Guild()   
    if TMP3GuildChatAnnounce == true then TMP3GuildChatAnnounce = false
      else TMP3GuildChatAnnounce = true
        end
    if isPlaying == true and TMP3GuildChatAnnounce == true and TitanPanelSimpleMp3Chat == true and IsInGuild() then SendChatMessage("is now listening to "..TMP3SongInfo, "GUILD", TMP3Language, _)
      elseif TMP3GuildChatAnnounce == true and TitanPanelSimpleMp3Chat == true and (not IsInGuild()) then DEFAULT_CHAT_FRAME:AddMessage("Song info will be announce when you join a guild.")
  end
end 

function TitanPanelSimpleMp3Party()     
    if TMP3PartyChatAnnounce == true then TMP3PartyChatAnnounce = false
      else TMP3PartyChatAnnounce = true
        end
    if isPlaying == true and TMP3PartyChatAnnounce == true and TitanPanelSimpleMp3Chat == true and TMP3PartyNum > 0 then SendChatMessage("is now listening to "..TMP3SongInfo, "PARTY", TMP3Language, _)     
      elseif TMP3PartyChatAnnounce == true and TitanPanelSimpleMp3Chat == true and TMP3PartyNum == 0 then DEFAULT_CHAT_FRAME:AddMessage("Song info will be announced when you join a party.")
  end
end

function TitanPanelSimpleMp3Raid()    
    if TMP3RaidChatAnnounce == true then TMP3RaidChatAnnounce = false
      else TMP3RaidChatAnnounce = true
        end
    if isPlaying == true and TMP3RaidChatAnnounce == true and TitanPanelSimpleMp3Chat == true and UnitInRaid("player") then SendChatMessage("is now listening to "..TMP3SongInfo, "RAID", TMP3Language, _)      
      elseif TMP3RaidChatAnnounce == true and TitanPanelSimpleMp3Chat == true and (not UnitInRaid("player")) then DEFAULT_CHAT_FRAME:AddMessage("Song info will be announced when you join a raid.")      
  end
end

function TitanPanelSimpleMp3Emote()   
    if TMP3EmoteChatAnnounce == true then TMP3EmoteChatAnnounce = false
      else TMP3EmoteChatAnnounce = true
        end
    if isPlaying == true and TMP3EmoteChatAnnounce == true and TitanPanelSimpleMp3Chat == true then DoEmote("dance")
                                                                                                    SendChatMessage("is dancing to "..TMP3SongInfo, "EMOTE", TMP3Language, _)
  end
end

function TitanPanelSimpleMp3ChatOutput()
    if TPSong1 ~= TPSong2 and TMP3SayChatAnnounce == true and isPlaying == true then SendChatMessage("I'm listening to "..TMP3SongInfo, "SAY", TMP3Language, _)
      end
    if TPSong1 ~= TPSong2 and TMP3GuildChatAnnounce == true and isPlaying == true and IsInGuild() then SendChatMessage("is now listening to "..TMP3SongInfo, "GUILD", TMP3Language, _)
      end
    if TPSong1 ~= TPSong2 and TMP3PartyChatAnnounce == true and isPlaying == true and TMP3PartyNum > 0 then SendChatMessage("is now listening to "..TMP3SongInfo, "PARTY", TMP3Language, _)  
      end
    if TPSong1 ~= TPSong2 and TMP3RaidChatAnnounce == true and isPlaying == true and UnitInRaid("player") then SendChatMessage("is now listening to "..TMP3SongInfo, "RAID", TMP3Language, _)  
      end
    if TPSong1 ~= TPSong2 and TMP3EmoteChatAnnounce == true and isPlaying == true then DoEmote("dance")
                                                                                       SendChatMessage("is dancing to "..TMP3SongInfo, "EMOTE", TMP3Language, _)
      end
    TPSong2 = TPSong1 
end

function TitanPanelSimpleMp3Button_OnUpdate(self, elapsed)     
    if TitanPanelSimpleMp3Time == true then TMP3Time = TMP3Timer
      else TMP3Time = ""
    end  
    if Hr == 0 then THr = ""
      else THr = Hr
    end
    if Hr2 == 0 then THr2 = ""
      else THr2 = Hr2
    end  
    if Sec < 10 then TSec = "0"..Sec
      else TSec = Sec
    end
    if Sec2 < 10 then TSec2 = "0"..Sec2
      else TSec2 = Sec2
    end    
    if Smp3_Save.Remaining == true then TMP3Timer = THr..Min2..":"..TSec2
      elseif Smp3_Save.Remaining == false then TMP3Timer = THr..Min..":"..TSec    
    end
    TPSong1 = TMP3SongInfo
    if (not isPlaying == true) then TPSong2 = nil
      else TitanPanelSimpleMp3ChatOutput()
    end 
    local SliderVar = getglobal("SimpleMp3VolumeForm" .. "Slider")
    if SliderVar:GetValue() >= 0 and SliderVar:GetValue() < 0.2 then Button.registry.icon = "Interface\\AddOns\\TitanSimpleMp3\TitanSimpleMp3Vol5"
      elseif SliderVar:GetValue() >= 0.2 and SliderVar:GetValue() < 0.4 then Button.registry.icon = "Interface\\AddOns\\TitanSimpleMp3\\TitanSimpleMp3Vol4"
        elseif SliderVar:GetValue() >= 0.4 and SliderVar:GetValue() < 0.6 then Button.registry.icon = "Interface\\AddOns\\TitanSimpleMp3\\TitanSimpleMp3Vol3"
          elseif SliderVar:GetValue() >= 0.6 and SliderVar:GetValue() < 0.8 then Button.registry.icon = "Interface\\AddOns\\TitanSimpleMp3\\TitanSimpleMp3Vol2"
            elseif SliderVar:GetValue() >= 0.8 and SliderVar:GetValue() <= 1 then Button.registry.icon = "Interface\\AddOns\\TitanSimpleMp3\\TitanSimpleMp3Vol1"
              else Button.registry.icon = "Interface\\AddOns\\SimpleMp3\\Textures\\SimpleMp3MiniMapButton"            
  end
    TMP3PartyNum = GetNumPartyMembers()
    TitanPanelButton_UpdateButton(TMP3ID)
 end
